<!DOCTYPE HTML>
<html>

<head>
    <meta charset="utf-8">
    <style>
        #field {
            width: 200px;
            height: 150px;
            border: 10px groove black;
            background-color: #00FF00;
            position: relative;
            overflow: hidden;
            cursor: default;
        }

        #ball {
            position: absolute;
            top: 50%;
            left: 50%;
            width: 40px;
            height: 40px;
            transition: top 0.5s, left 0.5s;
        }
    </style>
</head>

<body style="height:2000px">

Кликните на любое место поля, чтобы мяч перелетел туда.
<br> Мяч никогда не вылетит за границы поля.


<div id="field">
    <img src="https://js.cx/clipart/ball.svg" id="ball"> . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
</div>

<script>
    let field = document.getElementById("field");
    let ball = document.getElementById("ball");

    field.addEventListener("click", function() {
        let fieldCoords = {
            x : field.offsetLeft + field.clientLeft,
            y : field.offsetTop + field.clientTop
        };

        let ballSize = {
            x : ball.clientWidth,
            y : ball.clientHeight
        };

        let ballCoords = {
            x : Math.max(0, Math.min(event.clientX - fieldCoords.x - ballSize.x / 2, Math.floor(field.clientWidth - ballSize.x))),
            y : Math.max(0, Math.min(event.clientY - fieldCoords.y - ballSize.y / 2, Math.floor(field.clientHeight - ballSize.y)))
        };

        ball.style.left = ballCoords.x + "px";
        ball.style.top = ballCoords.y + "px";
    });
</script>
</body>

</html>